;
;	>>> SV2K17 Invitro-System by JAC! <<<
;
;	Created for Sillyventure 2017 in Gdansk.
;
;	This file contains the object which can be included in banks that require it.
;
;	@com.wudsn.ide.asm.hardware=ATARI2600
;	@com.wudsn.ide.asm.mainsourcefile=SV2K17.asm

;===============================================================

;	Set object horizontal position
;	IN:  <A>=0..159
;	IN:  <X>=offset for "sta resp0,x", 0=P0, ...
;	OUT: <X> increased by 1, <A>=fine positioning value, C=0, Z=0


; 	lda #xxx		;Position between 0-159
;	ldx #object.p0		;Offset for resp0,x
;	jsr object.set_set_hpos	;Set position
;	...			;Set more position
;	jsr object.move_hpos	;Perform WSYNC/HMOVE/HMCLR

	.proc object		;Move objects
	p0 = 0	;Player 0
	p1 = 1	;Player 1
	m0 = 2	;Missle 0
	m1 = 3	;Missle 1
	bl = 4	;Ball

	.proc set_hpos		;Set object horizontal position
	.if .def set_hpos_sec_first
	.print "Using hpos with SEC first"
	sec			;2
	sta wsync		;3
	.else
	.print "Using hpos with WSYNC first"
	sta wsync		;3
	sec			;2
	.endif
without_sync			;Start without sync, carry and <A> must be adjusted accordingly
loop	sbc #$0f		;2 => 5*3 pixel = 15 pixel per interation 
	bcs loop			;2 => 5 cycles per iteration, branch must not cross page-boundary
	eor #$07		;2
	asl			;2
	asl			;2
	asl			;2
	asl			;2
	sta resp0,x		;4
	sta hmp0,x		;4 => Fine positioning value
	inx			;2
	rts			;6
	.endp			;End of set_hpos

;	assert_same_page set_hpos

	.proc move_hpos		;Store wsync, hmove and hmclr
	sta wsync
	sta hmove
:10	nop
	sta hmclr
	rts
	.endp
		
	.endp			;End of object
